#include <sys/types.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/wait.h>

int main ()
{
	/* The state of parent/child process can be observed, e.g., with ps -u.
 		initially: just the parent process
  		after 5 seconds:  parent and child, both sleeping
		after 15 seconds: child terminates, becomes zombie
		after 25 seconds: parent calls wait(), child disappears
		after 30 seconds: parent terminates
	   The processes can be watched p.ex. using "ps aux | grep wait"
	*/

	printf("[common] just waiting five seconds before forking...\n");
	sleep(5);
	if (fork()) {
		int c,result;
		printf("[parent] I'm waiting for a long time...\n");
		sleep(20);
		printf("[parent] Calling wait now\n");
		wait(&result);
		c = WEXITSTATUS(result);
		printf("[parent] Alas..., his last word was %d\n",c);
		sleep(5);
		printf("[parent] exiting...\n");
		exit(1);
	} else {
		int code = 5;
		printf("[child] I'm %d, and my parent is %d\n",
				getpid(),getppid());
		sleep(10);
		printf("[child] I'm tired, will exit with %d\n",code);
		exit(code);
	}
}
